local config = require("./config")

local function ModifyCaptureLoot(StaticItemId, Count, LootMultiplier)
    local NewCount = math.ceil(Count:get() * LootMultiplier)
    if NewCount <= 0 then
        StaticItemId:set(FName(0))
    else
        Count:set(NewCount)
    end
end

local function GetLootMultiplierByIdString(IdAsString)
    if (IdAsString == "Wool") then
        return config.Multipliers.Wool
    elseif (IdAsString == "Meat_SheepBall") then
        return config.Multipliers.Meat_SheepBall
    elseif (IdAsString == "Berries") then
        return config.Multipliers.Berries
    elseif (IdAsString == "Berries2") then
        return config.Multipliers.Berries2
    elseif (IdAsString == "Egg") then
        return config.Multipliers.Egg
    elseif (IdAsString == "Meat_ChickenPal") then
        return config.Multipliers.Meat_ChickenPal
    elseif (IdAsString == "BerrySeeds") then
        return config.Multipliers.BerrySeeds
    elseif (IdAsString == "Herbs") then
        return config.Multipliers.Herbs
    elseif (IdAsString == "Leather") then
        return config.Multipliers.Leather
    elseif (IdAsString == "FireOrgan") then
        return config.Multipliers.FireOrgan
    elseif (IdAsString == "PalFluid") then
        return config.Multipliers.PalFluid
    elseif (IdAsString == "ElectricOrgan") then
        return config.Multipliers.ElectricOrgan
    elseif (IdAsString == "Mushroom") then
        return config.Multipliers.Mushroom
    elseif (IdAsString == "IceOrgan") then
        return config.Multipliers.IceOrgan
    elseif (IdAsString == "PalItem_CaptainPenguin") then
        return config.Multipliers.PalItem_CaptainPenguin
    elseif (IdAsString == "PalItem_PlantSlime") then
        return config.Multipliers.PalItem_PlantSlime
    elseif (IdAsString == "Herbs") then
        return config.Multipliers.Herbs
    elseif (IdAsString == "Bone") then
        return config.Multipliers.Bone
    elseif (IdAsString == "Fiber") then
        return config.Multipliers.Fiber
    elseif (IdAsString == "TechnologyBook_G1") then
        return config.Multipliers.TechnologyBook_G1
    elseif (IdAsString == "TechnologyBook_G2") then
        return config.Multipliers.TechnologyBook_G2
    elseif (IdAsString == "TechnologyBook_G3") then
        return config.Multipliers.TechnologyBook_G3
    elseif (IdAsString == "Venom") then
        return config.Multipliers.Venom
    elseif (IdAsString == "PalUpgradeStone") then
        return config.Multipliers.PalUpgradeStone
    elseif (IdAsString == "PalUpgradeStone2") then
        return config.Multipliers.PalUpgradeStone2
    elseif (IdAsString == "PalUpgradeStone3") then
        return config.Multipliers.PalUpgradeStone3
    elseif (IdAsString == "Meat_Boar") then
        return config.Multipliers.Meat_Boar
    elseif (IdAsString == "Money") then
        return config.Multipliers.Money
    elseif (IdAsString == "Sapphire") then
        return config.Multipliers.Sapphire
    elseif (IdAsString == "Ruby") then
        return config.Multipliers.Ruby
    elseif (IdAsString == "Gunpowder") then
        return config.Multipliers.Gunpowder
    elseif (IdAsString == "PalItem_ColorfulBird") then
        return config.Multipliers.PalItem_ColorfulBird
    elseif (IdAsString == "WheatSeeds") then
        return config.Multipliers.WheatSeeds
    elseif (IdAsString == "Meat_CowPal") then
        return config.Multipliers.Meat_CowPal
    elseif (IdAsString == "Milk") then
        return config.Multipliers.Milk
    elseif (IdAsString == "LettuceSeeds") then
        return config.Multipliers.LettuceSeeds
    elseif (IdAsString == "TomatoSeeds") then
        return config.Multipliers.TomatoSeeds
    elseif (IdAsString == "Sweet") then
        return config.Multipliers.Sweet
    elseif (IdAsString == "PalOil") then
        return config.Multipliers.PalOil
    elseif (IdAsString == "Meat_BerryGoat") then
        return config.Multipliers.Meat_BerryGoat
    elseif (IdAsString == "Horn") then
        return config.Multipliers.Horn
    elseif (IdAsString == "Meat_Deer") then
        return config.Multipliers.Meat_Deer
    elseif (IdAsString == "Meat_LazyCatfish") then
        return config.Multipliers.Meat_LazyCatfish
    elseif (IdAsString == "TreasureBoxKey01") then
        return config.Multipliers.TreasureBoxKey01
    elseif (IdAsString == "TreasureBoxKey02") then
        return config.Multipliers.TreasureBoxKey02
    elseif (IdAsString == "TreasureBoxKey03") then
        return config.Multipliers.TreasureBoxKey03
    elseif (IdAsString == "Meat_Eagle") then
        return config.Multipliers.Meat_Eagle
    elseif (IdAsString == "Spear_QueenBee") then
        return config.Multipliers.Spear_QueenBee
    elseif (IdAsString == "Meat_IceDeer") then
        return config.Multipliers.Meat_IceDeer
    elseif (IdAsString == "Pal_crystal_S") then
        return config.Multipliers.Pal_crystal_S
    elseif (IdAsString == "CopperOre") then
        return config.Multipliers.CopperOre
    elseif (IdAsString == "Cake") then
        return config.Multipliers.Cake
    elseif (IdAsString == "MindControlDrug") then
        return config.Multipliers.MindControlDrug
    elseif (IdAsString == "Narcotic") then
        return config.Multipliers.Narcotic
    elseif (IdAsString == "IronIngot") then
        return config.Multipliers.IronIngot
    elseif (IdAsString == "PalItem_CatMage") then
        return config.Multipliers.PalItem_CatMage
    elseif (IdAsString == "Cloth") then
        return config.Multipliers.Cloth
    elseif (IdAsString == "Cloth2") then
        return config.Multipliers.Cloth2
    elseif (IdAsString == "Meat_Kelpie") then
        return config.Multipliers.Meat_Kelpie
    elseif (IdAsString == "Meat_SakuraSaurus") then
        return config.Multipliers.Meat_SakuraSaurus
    elseif (IdAsString == "Meat_GrassMammoth") then
        return config.Multipliers.Meat_GrassMammoth
    elseif (IdAsString == "Coal") then
        return config.Multipliers.Coal
    elseif (IdAsString == "StealIngot") then
        return config.Multipliers.StealIngot
    elseif (IdAsString == "Quartz") then
        return config.Multipliers.Quartz
    elseif (IdAsString == "CarbonFiber") then
        return config.Multipliers.CarbonFiber
    elseif (IdAsString == "Diamond") then
        return config.Multipliers.Diamond
    elseif (IdAsString == "PalCrystal_Ex") then
        return config.Multipliers.PalCrystal_Ex
    elseif (IdAsString == "Blueprint_IronArmorHeat_5") then
        return config.Multipliers.Blueprint_IronArmorHeat_5
    elseif (IdAsString == "Polymer") then
        return config.Multipliers.Polymer
    end
end

-- Unsure what 'isAssignPassive' is for
RegisterHook("/Script/Pal.PalNetworkPlayerComponent:RequestAddItem_ToServer", function(Context, StaticItemId, Count, isAssignPassive)
    local IdAsString = StaticItemId:get():ToString()
    local LootMultiplier = GetLootMultiplierByIdString(IdAsString) * config.GlobalMultiplier

    ModifyCaptureLoot(StaticItemId, Count, LootMultiplier)
end)