local config = require("./config")

local clientRestarted = false

local lastPlayer = nil

RegisterHook("/Script/Engine.PlayerController:ClientRestart", function(Context)
	Player = Context:get().Pawn
	local PalUtility = StaticFindObject("/Script/Pal.Default__PalUtility")
	if not clientRestarted then
		print("[GameplayTweaks] GameplayTweaks hooked on Client Restart!")
		GetPalGameSetting()
		GetPalCharacterMovementComponent()
		GetPalUIInsideBaseCampCanvas()
		GetPalBuildObjectPalStorage()
	end
	clientRestarted = true
end)

RegisterHook("/Script/Engine.PlayerController:ServerAcknowledgePossession", function(Context)
	Player = Context:get().Pawn
	local PalUtility = StaticFindObject("/Script/Pal.Default__PalUtility")
	if Player ~= lastPlayer and
		not PalUtility:IsPalMonster(lastPlayer) and
		not PalUtility:IsPalMonster(Player) then
		print("[GameplayTweaks] GameplayTweaks hooked on Server Acknowledge Possession!")
		GetPalGameSetting()
		GetPalCharacterMovementComponent()
		GetPalUIInsideBaseCampCanvas()
		GetPalBuildObjectPalStorage()
	end
	lastPlayer = Player
end)

function GetPalGameSetting()
	local PalUtility = StaticFindObject("/Script/Pal.Default__PalUtility")
	PalGameSetting = PalUtility:GetGameSetting(Player)
	print("[GameplayTweaks] Found PalGameSetting successfully!")
	DoPalGameSettingTweaks1(PalGameSetting)
	ExecuteWithDelay(5000, function()
		DoPalGameSettingTweaks2(PalGameSetting)
	end)
end

function GetPalCharacterMovementComponent()
	PalCharacterMovementComponent = Player:GetPalCharacterMovementComponent()
	print("[GameplayTweaks] Found PalCharacterMovementComponent successfully!")
	DoPalCharacterMovementComponentTweaks(PalCharacterMovementComponent)
end

function GetPalUIInsideBaseCampCanvas()
	PalUIInsideBaseCampCanvas = StaticFindObject("/Script/Pal.Default__PalUIInsideBaseCampCanvas")
	print("[GameplayTweaks] Found PalUIInsideBaseCampCanvas successfully!")
	DoPalUIInsideBaseCampCanvasTweaks(PalUIInsideBaseCampCanvas)
end

function GetPalBuildObjectPalStorage()
	PalBuildObjectPalStorage = StaticFindObject("/Script/Pal.Default__PalBuildObjectPalStorage")
	print("[GameplayTweaks] Found PalBuildObjectPalStorage successfully!")
	DoPalBuildObjectPalStorageTweaks(PalBuildObjectPalStorage)
end

function DoPalGameSettingTweaks1(var)
	-- Player settings
	var.OverWeightSpeedZero_AddPercent = config.OverWeightSpeedZero_AddPercent
	var.AutoHPRegene_Percent_perSecond = config.AutoHPRegene_Percent_perSecond
	var.AutoHPRegene_Percent_perSecond_Sleeping = config.AutoHPRegene_Percent_perSecond_Sleeping
	var.Starvation_DecreaseHP_Percent_perSecond = config.Starvation_DecreaseHP_Percent_perSecond
	var.StomachDecreace_perSecond_Player = config.StomachDecreace_perSecond_Player
	var.StomachDecreace_AutoHealing = config.StomachDecreace_AutoHealing
	var.StomachDecreace_WorkingRate = config.StomachDecreace_WorkingRate
	var.HungerStart_StomachValue = config.HungerStart_StomachValue
	var.PlayerHPRateFromRespawn = config.PlayerHPRateFromRespawn
	var.PlayerStomachRateFromRespawn = config.PlayerStomachRateFromRespawn
	var.StaminaRecover_PercentPerSecond = config.StaminaRecover_PercentPerSecond
	var.lowHealthEffectParcent = config.lowHealthEffectParcent
	var.BlockRespawnTime = config.BlockRespawnTime
	var.DefaultMaxInventoryWeight = config.DefaultMaxInventoryWeight
	var.DefaultTechnologyPoint = config.DefaultTechnologyPoint
	var.RemainderOfLife_Second = config.RemainderOfLife_Second

	-- Technology points settings
	var.bossTechnologyPointPerTowerBoss = config.bossTechnologyPointPerTowerBoss
	var.bossTechnologyPointPerNormalBoss = config.bossTechnologyPointPerNormalBoss
	var.TechnologyPoint_UnlockFastTravel = config.TechnologyPoint_UnlockFastTravel

	-- Player level settings
	var.StatusPointPerLevel = config.StatusPointPerLevel
	var.AddMaxHPPerStatusPoint = config.AddMaxHPPerStatusPoint
	var.AddMaxSPPerStatusPoint = config.AddMaxSPPerStatusPoint
	var.AddPowerPerStatusPoint = config.AddPowerPerStatusPoint
	var.AddMaxInventoryWeightPerStatusPoint = config.AddMaxInventoryWeightPerStatusPoint
	var.AddCaptureLevelPerStatusPoint = config.AddCaptureLevelPerStatusPoint
	var.AddWorkSpeedPerStatusPoint = config.AddWorkSpeedPerStatusPoint
	var.technologyPointPerLevel = config.technologyPointPerLevel

	-- Stamina Settings
	var.ClimbingStamina_Move = config.ClimbingStamina_Move
	var.ClimbingStamina_Jump = config.ClimbingStamina_Jump
	var.RideWazaStaminaRate = config.RideWazaStaminaRate
	var.FlyHover_SP = config.FlyHover_SP
	var.FlyHorizon_SP = config.FlyHorizon_SP
	var.FlyHorizon_Dash_SP = config.FlyHorizon_Dash_SP
	var.FlyVertical_SP = config.FlyVertical_SP
	var.JumpSP = config.JumpSP
	var.MeleeAttackSP = config.MeleeAttackSP
	var.SprintSP = config.SprintSP
	var.GliderSP = config.GliderSP
	var.Swimming_SP_Idle = config.Swimming_SP_Idle
	var.Swimming_SP_Swim = config.Swimming_SP_Swim
	var.Swimming_SP_DashSwim = config.Swimming_SP_DashSwim

	-- Base camp settings
	var.BaseCampAreaRange = config.BaseCampAreaRange
	var.BaseCampPalFindWorkRange = config.BaseCampPalFindWorkRange
	var.BaseCampFoliageWorkableRange = config.BaseCampFoliageWorkableRange
	var.WorkAmountBySecForPlayer = config.WorkAmountBySecForPlayer
	var.WorkerCollectResourceStackMaxNum = config.WorkerCollectResourceStackMaxNum
	var.FarmCropGrowupSpeedBySec = config.FarmCropGrowupSpeedBySec
	var.FarmCropIncreaseRateByWaterFillRate = config.FarmCropIncreaseRateByWaterFillRate
	var.InvadeProbability = config.InvadeProbability
	var.VisitorNPCProbability = config.VisitorNPCProbability

	-- Time settings
	var.PalWorldMinutes_RealOneMinute = config.PalWorldMinutes_RealOneMinute

	-- World map settings
	var.worldmapUIMaskClearSize = config.worldmapUIMaskClearSize
	var.worldmapUIMaxMarker = config.worldmapUIMaxMarker

	-- Pal settings
	var.RarePal_AppearanceProbability = config.RarePal_AppearanceProbability
	var.RarePal_LevelMultiply = config.RarePal_LevelMultiply
	var.BossOrRarePal_TalentMin = config.BossOrRarePal_TalentMin
	var.PalBoxReviveTime = config.PalBoxReviveTime
	var.AutoSANRegene_Percent_perSecond_PalStorage = config.AutoSANRegene_Percent_perSecond_PalStorage
	var.StomachDecreace_perSecond_Monster = config.StomachDecreace_perSecond_Monster

	-- Uncategorized
	var.StomachDecreaceRate_GroundRide_Sprint = config.StomachDecreaceRate_GroundRide_Sprint
	var.StomachDecreaceRate_WaterRide = config.StomachDecreaceRate_WaterRide
	var.StomachDecreaceRate_WaterRide_Sprint = config.StomachDecreaceRate_WaterRide_Sprint
	var.StomachDecreaceRate_FlyRide = config.StomachDecreaceRate_FlyRide
	var.StomachDecreaceRate_FlyRide_Sprint = config.StomachDecreaceRate_FlyRide_Sprint
	var.EnemyCampRespawnCoolTime = config.EnemyCampRespawnCoolTime
	var.DecreaseSanity_Hunger = config.DecreaseSanity_Hunger
	var.DecreaseSanity_Starvation = config.DecreaseSanity_Starvation
	var.BuildExp = config.BuildExp
	var.CraftExp = config.CraftExp
	var.ResuscitationTime = config.ResuscitationTime
	print("[GameplayTweaks] Did PalGameSetting tweaks successfully!")
end

function DoPalGameSettingTweaks2(var)
	-- Player settings
	var.OverWeightSpeedZero_AddPercent = config.OverWeightSpeedZero_AddPercent
	var.AutoHPRegene_Percent_perSecond = config.AutoHPRegene_Percent_perSecond
	var.AutoHPRegene_Percent_perSecond_Sleeping = config.AutoHPRegene_Percent_perSecond_Sleeping
	var.Starvation_DecreaseHP_Percent_perSecond = config.Starvation_DecreaseHP_Percent_perSecond
	var.StomachDecreace_perSecond_Player = config.StomachDecreace_perSecond_Player
	var.StomachDecreace_AutoHealing = config.StomachDecreace_AutoHealing
	var.StomachDecreace_WorkingRate = config.StomachDecreace_WorkingRate
	var.HungerStart_StomachValue = config.HungerStart_StomachValue
	var.PlayerHPRateFromRespawn = config.PlayerHPRateFromRespawn
	var.PlayerStomachRateFromRespawn = config.PlayerStomachRateFromRespawn
	var.StaminaRecover_PercentPerSecond = config.StaminaRecover_PercentPerSecond
	var.lowHealthEffectParcent = config.lowHealthEffectParcent
	var.BlockRespawnTime = config.BlockRespawnTime
	var.DefaultMaxInventoryWeight = config.DefaultMaxInventoryWeight
	var.DefaultTechnologyPoint = config.DefaultTechnologyPoint
	var.RemainderOfLife_Second = config.RemainderOfLife_Second

	-- Technology points settings
	var.bossTechnologyPointPerTowerBoss = config.bossTechnologyPointPerTowerBoss
	var.bossTechnologyPointPerNormalBoss = config.bossTechnologyPointPerNormalBoss
	var.TechnologyPoint_UnlockFastTravel = config.TechnologyPoint_UnlockFastTravel

	-- Player level settings
	var.StatusPointPerLevel = config.StatusPointPerLevel
	var.AddMaxHPPerStatusPoint = config.AddMaxHPPerStatusPoint
	var.AddMaxSPPerStatusPoint = config.AddMaxSPPerStatusPoint
	var.AddPowerPerStatusPoint = config.AddPowerPerStatusPoint
	var.AddMaxInventoryWeightPerStatusPoint = config.AddMaxInventoryWeightPerStatusPoint
	var.AddCaptureLevelPerStatusPoint = config.AddCaptureLevelPerStatusPoint
	var.AddWorkSpeedPerStatusPoint = config.AddWorkSpeedPerStatusPoint
	var.technologyPointPerLevel = config.technologyPointPerLevel

	-- Stamina Settings
	var.ClimbingStamina_Move = config.ClimbingStamina_Move
	var.ClimbingStamina_Jump = config.ClimbingStamina_Jump
	var.RideWazaStaminaRate = config.RideWazaStaminaRate
	var.FlyHover_SP = config.FlyHover_SP
	var.FlyHorizon_SP = config.FlyHorizon_SP
	var.FlyHorizon_Dash_SP = config.FlyHorizon_Dash_SP
	var.FlyVertical_SP = config.FlyVertical_SP
	var.JumpSP = config.JumpSP
	var.MeleeAttackSP = config.MeleeAttackSP
	var.SprintSP = config.SprintSP
	var.GliderSP = config.GliderSP
	var.Swimming_SP_Idle = config.Swimming_SP_Idle
	var.Swimming_SP_Swim = config.Swimming_SP_Swim
	var.Swimming_SP_DashSwim = config.Swimming_SP_DashSwim

	-- Base camp settings
	var.BaseCampAreaRange = config.BaseCampAreaRange
	var.BaseCampPalFindWorkRange = config.BaseCampPalFindWorkRange
	var.BaseCampFoliageWorkableRange = config.BaseCampFoliageWorkableRange
	var.WorkAmountBySecForPlayer = config.WorkAmountBySecForPlayer
	var.WorkerCollectResourceStackMaxNum = config.WorkerCollectResourceStackMaxNum
	var.FarmCropGrowupSpeedBySec = config.FarmCropGrowupSpeedBySec
	var.FarmCropIncreaseRateByWaterFillRate = config.FarmCropIncreaseRateByWaterFillRate
	var.InvadeProbability = config.InvadeProbability
	var.VisitorNPCProbability = config.VisitorNPCProbability

	-- Time settings
	var.PalWorldMinutes_RealOneMinute = config.PalWorldMinutes_RealOneMinute

	-- World map settings
	var.worldmapUIMaskClearSize = config.worldmapUIMaskClearSize
	var.worldmapUIMaxMarker = config.worldmapUIMaxMarker

	-- Pal settings
	var.RarePal_AppearanceProbability = config.RarePal_AppearanceProbability
	var.RarePal_LevelMultiply = config.RarePal_LevelMultiply
	var.BossOrRarePal_TalentMin = config.BossOrRarePal_TalentMin
	var.PalBoxReviveTime = config.PalBoxReviveTime
	var.AutoSANRegene_Percent_perSecond_PalStorage = config.AutoSANRegene_Percent_perSecond_PalStorage
	var.StomachDecreace_perSecond_Monster = config.StomachDecreace_perSecond_Monster

	-- Uncategorized
	var.StomachDecreaceRate_GroundRide_Sprint = config.StomachDecreaceRate_GroundRide_Sprint
	var.StomachDecreaceRate_WaterRide = config.StomachDecreaceRate_WaterRide
	var.StomachDecreaceRate_WaterRide_Sprint = config.StomachDecreaceRate_WaterRide_Sprint
	var.StomachDecreaceRate_FlyRide = config.StomachDecreaceRate_FlyRide
	var.StomachDecreaceRate_FlyRide_Sprint = config.StomachDecreaceRate_FlyRide_Sprint
	var.EnemyCampRespawnCoolTime = config.EnemyCampRespawnCoolTime
	var.DecreaseSanity_Hunger = config.DecreaseSanity_Hunger
	var.DecreaseSanity_Starvation = config.DecreaseSanity_Starvation
	var.BuildExp = config.BuildExp
	var.CraftExp = config.CraftExp
	var.ResuscitationTime = config.ResuscitationTime
end

function DoPalCharacterMovementComponentTweaks(var)
	var.MaxWalkSpeed = config.MaxWalkSpeed
	var.SprintMaxSpeed = config.SprintMaxSpeed
	var.ClimbMaxSpeed = config.ClimbMaxSpeed
	var.MaxSwimSpeed = config.MaxSwimSpeed
	var.DashSwimMaxSpeed = config.DashSwimMaxSpeed
	print("[GameplayTweaks] Did PalCharacterMovementComponent tweaks successfully!")
end

function DoPalUIInsideBaseCampCanvasTweaks(var)
	var.palboxAreaRange = config.palboxAreaRange
	print("[GameplayTweaks] Did PalUIInsideBaseCampCanvas tweaks successfully!")
end

function DoPalBuildObjectPalStorageTweaks(var)
	var.BaseCampAreaRangeStorage = config.BaseCampAreaRangeStorage
	var.ChestSlotNum = config.ChestSlotNum
	print("[GameplayTweaks] Did PalBuildObjectPalStorage tweaks successfully!")
end

function DoTweaks()
	PalGameSetting.RarePal_AppearanceProbability = config.RarePal_AppearanceProbability
	PalGameSetting.ClimbingStamina_Move = config.ClimbingStamina_Move
	PalGameSetting.ClimbingStamina_Jump = config.ClimbingStamina_Jump
	PalGameSetting.RideWazaStaminaRate = config.RideWazaStaminaRate
	PalGameSetting.FlyHover_SP = config.FlyHover_SP
	PalGameSetting.FlyHorizon_SP = config.FlyHorizon_SP
	PalGameSetting.FlyHorizon_Dash_SP = config.FlyHorizon_Dash_SP
	PalGameSetting.FlyVertical_SP = config.FlyVertical_SP
	PalGameSetting.JumpSP = config.JumpSP
	PalGameSetting.MeleeAttackSP = config.MeleeAttackSP
	PalGameSetting.SprintSP = config.SprintSP
	PalGameSetting.GliderSP = config.GliderSP
	PalGameSetting.Swimming_SP_Idle = config.Swimming_SP_Idle
	PalGameSetting.Swimming_SP_Swim = config.Swimming_SP_Swim
	PalGameSetting.Swimming_SP_DashSwim = config.Swimming_SP_DashSwim
	PalGameSetting.OverWeightSpeedZero_AddPercent = config.OverWeightSpeedZero_AddPercent
	PalGameSetting.AutoHPRegene_Percent_perSecond = config.AutoHPRegene_Percent_perSecond
	PalGameSetting.AutoHPRegene_Percent_perSecond_Sleeping = config.AutoHPRegene_Percent_perSecond_Sleeping
	PalGameSetting.Starvation_DecreaseHP_Percent_perSecond = config.Starvation_DecreaseHP_Percent_perSecond
	PalGameSetting.StomachDecreace_perSecond_Monster = config.StomachDecreace_perSecond_Monster
	PalGameSetting.StomachDecreace_perSecond_Player = config.StomachDecreace_perSecond_Player
	PalGameSetting.StomachDecreace_AutoHealing = config.StomachDecreace_AutoHealing
	PalGameSetting.StomachDecreace_WorkingRate = config.StomachDecreace_WorkingRate
	PalGameSetting.HungerStart_StomachValue = config.HungerStart_StomachValue
	PalGameSetting.StaminaRecover_PercentPerSecond = config.StaminaRecover_PercentPerSecond
	PalGameSetting.BuildExp = config.BuildExp
	PalGameSetting.CraftExp = config.CraftExp
	PalGameSetting.lowHealthEffectParcent = config.lowHealthEffectParcent
	PalGameSetting.BlockRespawnTime = config.BlockRespawnTime
	PalGameSetting.DefaultMaxInventoryWeight = config.DefaultMaxInventoryWeight
	PalGameSetting.StatusPointPerLevel = config.StatusPointPerLevel
	PalGameSetting.AddMaxHPPerStatusPoint = config.AddMaxHPPerStatusPoint
	PalGameSetting.AddMaxSPPerStatusPoint = config.AddMaxSPPerStatusPoint
	PalGameSetting.AddPowerPerStatusPoint = config.AddPowerPerStatusPoint
	PalGameSetting.AddMaxInventoryWeightPerStatusPoint = config.AddMaxInventoryWeightPerStatusPoint
	PalGameSetting.AddCaptureLevelPerStatusPoint = config.AddCaptureLevelPerStatusPoint
	PalGameSetting.AddWorkSpeedPerStatusPoint = config.AddWorkSpeedPerStatusPoint
	--PalGameSetting.AddMaxHPPerHPRank = AddMaxHPPerHPRank
	--PalGameSetting.AddAttackPerAttackRank = AddAttackPerAttackRank
	--PalGameSetting.AddDefencePerDefenceRank = AddDefencePerDefenceRank
	--PalGameSetting.AddWorkSpeedPerWorkSpeedRank = AddWorkSpeedPerWorkSpeedRank
	PalGameSetting.EnemyCampRespawnCoolTime = config.EnemyCampRespawnCoolTime
	--PalGameSetting.PalBoxReviveTime = config.PalBoxReviveTime
	PalGameSetting.BaseCampAreaRange = config.BaseCampAreaRange
	--
	PalUIInsideBaseCampCanvas.palboxAreaRange = config.palboxAreaRange
	--
	PalBuildObjectPalStorage.BaseCampAreaRangeStorage = config.BaseCampAreaRangeStorage
	PalBuildObjectPalStorage.ChestSlotNum = config.ChestSlotNum
	--
	PalCharacterMovementComponent.MaxWalkSpeed = config.MaxWalkSpeed
	PalCharacterMovementComponent.SprintMaxSpeed = config.SprintMaxSpeed
	PalCharacterMovementComponent.ClimbMaxSpeed = config.ClimbMaxSpeed
	PalCharacterMovementComponent.DashSwimMaxSpeed = config.DashSwimMaxSpeed
	PalCharacterMovementComponent.MaxSwimSpeed = config.MaxSwimSpeed

	print("[GameplayTweaks] Did tweaks successfully!")
end
